﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TextEditorInGridCaptureTextONntering
{
    public class TextCol : INotifyPropertyChanged
    {
        private string txt;
        private PropertyChangedEventHandler propertyChangedDelegate;


        public TextCol(string txtC)
        { this.txt = txtC;  }

        public string Txt
        {
            get { return txt; }
            set
            {
                if (string.Compare(this.txt, value, false) == 0)
                    return;
                this.txt = value;
                if (this.propertyChangedDelegate != null)
                    this.propertyChangedDelegate(this, new PropertyChangedEventArgs("Txt"));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged
        {
            add
            {
                if (this.propertyChangedDelegate == null)
                    this.propertyChangedDelegate = value;
                else
                    this.propertyChangedDelegate = (PropertyChangedEventHandler)System.Delegate.Combine(this.propertyChangedDelegate, value);
            }
            remove
            {
                if(this.propertyChangedDelegate !=null   )
                    this.propertyChangedDelegate = (PropertyChangedEventHandler)System.Delegate.Remove(this.propertyChangedDelegate, value);
            }
        }
    }
}
