﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;

namespace TextEditorInGridCaptureTextONntering
{
    public partial class ucTextCol : UserControl
    {
        private TextCol txtCol;
        bool isSettingsUltraTextEditorText = false;
        public ucTextCol()
        {
            InitializeComponent();
        }
        public TextCol TextCol
        {
            get { return txtCol; }
            set
            {
                if (this.txtCol == value)
                    return;
                if (this.txtCol != null)
                    this.txtCol.PropertyChanged -= new PropertyChangedEventHandler(TxtCol_PropertyChanged);
                txtCol = value;
                this.UpdateUI();

                if (this.txtCol != null)
                    this.txtCol.PropertyChanged += new PropertyChangedEventHandler(TxtCol_PropertyChanged);
            }
        }
        private void TxtCol_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            this.UpdateUI();
        }
        private void UpdateUI()
        {
            if (this.txtCol == null)
            { this.ResetTxtCol(); }

            // Call the SetUltraTextEditorText and pass in false so we don't fire a notification. 
            //this.ultraTextEditor1.Text = this.txtCol.Txt;
            this.SetUltraTextEditorText(this.txtCol.Txt, false);
        }
        private void ResetTxtCol()
        {
            // Call the SetUltraTextEditorText and pass in false so we don't fire a notification. 
            //this.ultraTextEditor1.Text = null;
            this.SetUltraTextEditorText(null, false);
        }
        private void ultraTextEditor1_TextChanged(object sender, EventArgs e)
        {
            string tx = ((UltraTextEditor)sender).Text;
            if (sender == this.ultraTextEditor1)
            { this.txtCol.Txt = tx; }

            // Fire TextChanged, but only when this.isSettingsUltraTextEditorText is false, which indicates
            // the we are not setting the text in code, but rather, the user is typing. 
            if (!this.isSettingsUltraTextEditorText)
                this.OnTextChanged(e);
        }   
        
        private void SetUltraTextEditorText(string txt, bool notify)
        {
            // Set a flag to let the TextChanged event know that it should not fire TextChanged of
            // this UserControl. 
            var originalIsSettingsUltraTextEditorText = this.isSettingsUltraTextEditorText;
            this.isSettingsUltraTextEditorText = !notify;
            try
            {
                this.ultraTextEditor1.Text = txt;
            }
            finally
            {
                this.isSettingsUltraTextEditorText = originalIsSettingsUltraTextEditorText;
            }
        }
        private void ultraTextEditor1_ValueChanged(object sender, EventArgs e)
        {
            ////this.ultraTextEditor1.Appearance.ForeColor = Color.Red;
        }
    }
}
